* PROGRAM...:  INDEX.PRG
* AUTHOR....:   ""
* DATE......:  24  1987
* NOTICE....:  Copyright (C) 1987,  ""
* NOTES.....:     

*      
PARAMETER db

CLEAR
SET INTENSITY OFF

IF "" <> db
	dbf=UPPER(db)
	file= "&dbf"+".DBF"
	IF .NOT. FILE("&file")
		? "&file"+"   "
        ? "  DOS"
		RETURN
	ENDIF
	@ 10, 47 SAY dbf PICT "@!"
ENDIF

	frame = ""
	@ 6,22,8,56 BOX frame

	@ 7,25 SAY "   "

	@ 1,0,5,79 BOX frame

	stat_line = ""
	SET COLOR TO 0/7
	com_line="INDEX ON "
	@ 23,0 SAY com_line + SPACE(79-LEN(com_line))
	SET COLOR TO 7/0

	@ 10, 22 SAY "    ...."

* If no file name provided in command line prompt for one and check
* validity
	IF "" = db
		DO WHILE .T.
			dbf=SPACE(10)
			@ 10, 53 GET dbf PICT "@!"
			READ
			dbf= TRIM(dbf)
			file= "&dbf"+".DBF"
			IF .NOT. FILE("&file")
				@ 21, 0
				@ 21, 27 SAY "&file"+"   "
			ELSE
				EXIT
			ENDIF
		ENDDO
	ENDIF

* reset default drive if necessary so that .NTX is on same drive 
* as .DBF
IF SUBSTR(dbf,2,1)=":"
     start=3
     drive=SUBSTR(dbf,1,1)
     SET DEFAULT TO &drive
ELSE
      start=1
ENDIF

* Create an index file name
ntx_file=SUBSTR(dbf,start,2)+"_"+"INDEX"

@ 21,0
@ 22,3 SAY ": &file"
USE &dbf

* erase smaller box
@ 6,22,8,56 BOX ""
@ 7,20 SAY REPL("",36)

add_on=""
a=1
row = 2
col = 3

* get fieldnames and print in box
DO WHILE a < 26
	FOR x = a TO a+4
		@ row,col say fieldname(x)
		row=row+1
	NEXT
	IF "" = FIELDNAME(x)
		EXIT
	ELSE
	row=2
	a=a+5
	col=col+15
	ENDIF
ENDDO

over_write="N"
DO WHILE .T.
	@ 11,22 SAY "NTX   ..:"
	@ 11,42  GET ntx_file PICT "@!"
	READ
	IF start = 3
		ntx_file=drive+":"+ntx_file
	ENDIF
	IF FILE("&NTX_FILE..NTX")
		@ 21,15 SAY "  ... ? (Y/N)" GET over_write PICT "!"
		READ
		IF over_write = "Y"
   			EXIT
		ENDIF
	ELSE
		EXIT
	ENDIF
ENDDO
@ 21,0

row=12
field="f"
index_size=0
cmd_size=21
field_cnt=0
DO WHILE "" <> TRIM(field) .and. index_size<=100 .and. cmd_size<=254
	@ row,22 SAY "      ....:"
    DO WHILE .T. .and. "" <> TRIM(field)
    	field=SPACE(10)
    	@ row,46 GET field PICT "!!!!!!!!!!"
    	READ
		@ 21,0
 		field=TRIM(field)
  		DO CASE
         	CASE field="RECNO()"
           		field="STR(RECNO(),10)"
              	field_cnt=field_cnt+1
              	index_size=index_size+10
           		EXIT
     		CASE TYPE("&field")="U" .and. "" <> field
       			@ 21,0
       			@ 21,27 SAY "   "
     		CASE TYPE("&field")="M"
       			@ 21,0
				@ 21,15 SAY " ,    memo   ?"
     		CASE TYPE("&field")="L"
       			@ 21,0
       			@ 21,22 SAY "      "
     	OTHERWISE
        DO CASE
         	CASE TYPE("&field")="N"
				* STR() with no parameters returns field length & 
				* decimals in 
          		index_size=index_size+LEN(STR(&field))
          		field_cnt=field_cnt+1
           		field="STR(&field)"
          		EXIT
         	CASE TYPE("&field")="D"
           		field="DTOC(&field)"
           		index_size=index_size+8
           		field_cnt=field_cnt+1
           		EXIT
        OTHERWISE
         	IF ""=TRIM(field)
				add_on=" TO "+ntx_file
           		EXIT
         	ELSE
           		index_size=index_size+LEN(&field) 
           		field_cnt=field_cnt+1
           		EXIT
         	ENDIF
		ENDCASE
  		ENDCASE
	ENDDO
       stat_line=stat_line+"+"+TRIM(field)
* If first field print on command line without "+" otherwise
* add a "+"
	   IF "INDEX ON" = TRIM(com_line)
	 	  com_line=com_line+TRIM(field)
	   ELSE
        com_line=com_line+"+"+TRIM(field)
* If command line larger than 78 scroll it off left side of screen
		wide =LEN(com_line)
		IF wide > 78
			com_line=SUBSTR(com_line,wide-78)
	    ENDIF
	   ENDIF	
	   SET COLOR TO 0/7
	   @ 23,0 SAY com_line + SPACE(79-LEN(com_line))
	   SET COLOR TO 7/0
       row=row+1
       cmd_size=LEN(stat_line)+21
	   @ 22,52 SAY "  ="+STR(index_size,3)
ENDDO
*Put finishing touches on command line
IF LEN(com_line) > 78
	com_line=SUBSTR(com_line,LEN(add_on)+1)+add_on
ELSE
	com_line=SUBSTR(com_line,1,LEN(com_line)-1)+add_on
ENDIF
SET COLOR TO 0/7
@ 23,0 SAY com_line + SPACE(79-LEN(com_line))
SET COLOR TO 7/0
If index_size = 0
    CLEAR
  	? "      "
	? "  DOS"
  	RETURN
ENDIF
If index_size > 100
    CLEAR
  	? "   -  100 -   "
	? "  DOS"
  	RETURN
ENDIF
IF cmd_size > 254
    CLEAR
  	? "    -   "
	? "  DOS"
  	RETURN
ENDIF
*  If field date or numeric and only field, strip functions
IF field_cnt=1 .and. "DTOC(" $ stat_line
   	stat_line=SUBSTR(stat_line,7,AT(")",stat_line)-7)
    com_line="INDEX ON "+stat_line+add_on
	SET COLOR TO 0/7
	@ 23,0 SAY com_line + SPACE(79-LEN(com_line))
	SET COLOR TO 7/0
ELSE
	IF field_cnt=1 .and. "STR(" $ stat_line
  		stat_line=SUBSTR(stat_line,6,AT(")",stat_line)-6)
        com_line="INDEX ON "+stat_line+add_on
		SET COLOR TO 0/7
		@ 23,0 SAY com_line + SPACE(79-LEN(com_line))
		SET COLOR TO 7/0
	ELSE
		stat_line=SUBSTR(stat_line,2,LEN(stat_line)-2)
	ENDIF
ENDIF

records = STR(LASTREC())
 
INDEX ON &stat_line TO &ntx_file
CLOSE DATABASES

CLEAR
? "<<<<    >>>>"
? "&records   "
